const char * re_squared_lj = 

"#ifdef NV_KERNEL\n"
"#define GLOBAL_ID_X threadIdx.x+mul24(blockIdx.x,blockDim.x)\n"
"#define GLOBAL_ID_Y threadIdx.y+mul24(blockIdx.y,blockDim.y)\n"
"#define GLOBAL_SIZE_X mul24(gridDim.x,blockDim.x);\n"
"#define GLOBAL_SIZE_Y mul24(gridDim.y,blockDim.y);\n"
"#define THREAD_ID_X threadIdx.x\n"
"#define THREAD_ID_Y threadIdx.y\n"
"#define BLOCK_ID_X blockIdx.x\n"
"#define BLOCK_ID_Y blockIdx.y\n"
"#define BLOCK_SIZE_X blockDim.x\n"
"#define BLOCK_SIZE_Y blockDim.y\n"
"#define __kernel extern \"C\" __global__\n"
"#define __local __shared__\n"
"#define __global\n"
"#define restrict __restrict__\n"
"#define atom_add atomicAdd\n"
"#define ucl_inline static __inline__ __device__\n"
"#ifdef __CUDA_ARCH__\n"
"#define ARCH __CUDA_ARCH__\n"
"#else\n"
"#define ARCH 100\n"
"#endif\n"
"#if (ARCH < 200)\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 16\n"
"#define BLOCK_NBOR_BUILD 64\n"
"#define BLOCK_PAIR 64\n"
"#define BLOCK_BIO_PAIR 64\n"
"#define MAX_SHARED_TYPES 8\n"
"#else\n"
"#if (ARCH < 300)\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_NBOR_BUILD 128\n"
"#define BLOCK_PAIR 128\n"
"#define BLOCK_BIO_PAIR 128\n"
"#define MAX_SHARED_TYPES 8\n"
"#else\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_NBOR_BUILD 128\n"
"#define BLOCK_PAIR 256\n"
"#define BLOCK_BIO_PAIR 256\n"
"#define BLOCK_ELLIPSE 128\n"
"#define MAX_SHARED_TYPES 11\n"
"#ifdef _SINGLE_SINGLE\n"
"#define shfl_xor __shfl_xor\n"
"#else\n"
"ucl_inline double shfl_xor(double var, int laneMask, int width) {\n"
"  int2 tmp;\n"
"  tmp.x = __double2hiint(var);\n"
"  tmp.y = __double2loint(var);\n"
"  tmp.x = __shfl_xor(tmp.x,laneMask,width);\n"
"  tmp.y = __shfl_xor(tmp.y,laneMask,width);\n"
"  return __hiloint2double(tmp.x,tmp.y);\n"
"}\n"
"#endif\n"
"#endif\n"
"#endif\n"
"#define WARP_SIZE 32\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#ifdef _DOUBLE_DOUBLE\n"
"#define fetch4(ans,i,pos_tex) {                        \\\n"
"  int4 xy = tex1Dfetch(pos_tex,i*2);                   \\\n"
"  int4 zt = tex1Dfetch(pos_tex,i*2+1);                 \\\n"
"  ans.x=__hiloint2double(xy.y, xy.x);                  \\\n"
"  ans.y=__hiloint2double(xy.w, xy.z);                  \\\n"
"  ans.z=__hiloint2double(zt.y, zt.x);                  \\\n"
"  ans.w=__hiloint2double(zt.w, zt.z);                  \\\n"
"}\n"
"#define fetch(ans,i,q_tex) {                           \\\n"
"  int2 qt = tex1Dfetch(q_tex,i);                       \\\n"
"  ans=__hiloint2double(qt.y, qt.x);                    \\\n"
"}\n"
"#else\n"
"#define fetch4(ans,i,pos_tex) ans=tex1Dfetch(pos_tex, i);\n"
"#define fetch(ans,i,q_tex) ans=tex1Dfetch(q_tex,i);\n"
"#endif\n"
"#if (__CUDA_ARCH__ < 200)\n"
"#define fast_mul __mul24\n"
"#define MEM_THREADS 16\n"
"#else\n"
"#define fast_mul(X,Y) (X)*(Y)\n"
"#define MEM_THREADS 32\n"
"#endif\n"
"#ifdef CUDA_PRE_THREE\n"
"struct __builtin_align__(16) _double4\n"
"{\n"
"  double x, y, z, w;\n"
"};\n"
"typedef struct _double4 double4;\n"
"#endif\n"
"#ifdef _DOUBLE_DOUBLE\n"
"#define ucl_exp exp\n"
"#define ucl_powr pow\n"
"#define ucl_atan atan\n"
"#define ucl_cbrt cbrt\n"
"#define ucl_ceil ceil\n"
"#define ucl_abs fabs\n"
"#define ucl_rsqrt rsqrt\n"
"#define ucl_sqrt sqrt\n"
"#define ucl_recip(x) ((numtyp)1.0/(x))\n"
"#else\n"
"#define ucl_atan atanf\n"
"#define ucl_cbrt cbrtf\n"
"#define ucl_ceil ceilf\n"
"#define ucl_abs fabsf\n"
"#define ucl_recip(x) ((numtyp)1.0/(x))\n"
"#define ucl_rsqrt rsqrtf\n"
"#define ucl_sqrt sqrtf\n"
"#ifdef NO_HARDWARE_TRANSCENDENTALS\n"
"#define ucl_exp expf\n"
"#define ucl_powr powf\n"
"#else\n"
"#define ucl_exp __expf\n"
"#define ucl_powr __powf\n"
"#endif\n"
"#endif\n"
"#endif\n"
"#ifdef NV_GENERIC_OCL\n"
"#define USE_OPENCL\n"
"#define fast_mul mul24\n"
"#define MEM_THREADS 16\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 1\n"
"#define BLOCK_PAIR 64\n"
"#define MAX_SHARED_TYPES 8\n"
"#define BLOCK_NBOR_BUILD 64\n"
"#define BLOCK_BIO_PAIR 64\n"
"#define WARP_SIZE 32\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#endif\n"
"#ifdef FERMI_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 32\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_PAIR 128\n"
"#define MAX_SHARED_TYPES 11\n"
"#define BLOCK_NBOR_BUILD 128\n"
"#define BLOCK_BIO_PAIR 128\n"
"#define WARP_SIZE 32\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#endif\n"
"#ifdef KEPLER_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 32\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_PAIR 256\n"
"#define MAX_SHARED_TYPES 11\n"
"#define BLOCK_NBOR_BUILD 128\n"
"#define BLOCK_BIO_PAIR 256\n"
"#define BLOCK_ELLIPSE 128\n"
"#define WARP_SIZE 32\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#ifndef NO_OCL_PTX\n"
"#define ARCH 300\n"
"#ifdef _SINGLE_SINGLE\n"
"inline float shfl_xor(float var, int laneMask, int width) {\n"
"  float ret;\n"
"  int c;\n"
"  c = ((WARP_SIZE-width) << 8) | 0x1f;\n"
"  asm volatile (\"shfl.bfly.b32 %0, %1, %2, %3;\" : \"=f\"(ret) : \"f\"(var), \"r\"(laneMask), \"r\"(c));\n"
"  return ret;\n"
"}\n"
"#else\n"
"#pragma OPENCL EXTENSION cl_khr_fp64 : enable\n"
"inline double shfl_xor(double var, int laneMask, int width) {\n"
"  int c = ((WARP_SIZE-width) << 8) | 0x1f;\n"
"  int x,y,x2,y2;\n"
"  double ans;\n"
"  asm volatile (\"mov.b64 {%0, %1}, %2;\" : \"=r\"(y), \"=r\"(x) : \"d\"(var));\n"
"  asm volatile (\"shfl.bfly.b32 %0, %1, %2, %3;\" : \"=r\"(x2) : \"r\"(x), \"r\"(laneMask), \"r\"(c));\n"
"  asm volatile (\"shfl.bfly.b32 %0, %1, %2, %3;\" : \"=r\"(y2) : \"r\"(y), \"r\"(laneMask), \"r\"(c));\n"
"  asm volatile (\"mov.b64 %0, {%1, %2};\" : \"=d\"(ans) : \"r\"(y2), \"r\"(x2));\n"
"  return ans;\n"
"}\n"
"#endif\n"
"#endif\n"
"#endif\n"
"#ifdef CYPRESS_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 32\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_PAIR 128\n"
"#define MAX_SHARED_TYPES 8\n"
"#define BLOCK_NBOR_BUILD 64\n"
"#define BLOCK_BIO_PAIR 64\n"
"#define WARP_SIZE 64\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#endif\n"
"#ifdef INTEL_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 16\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 1\n"
"#define BLOCK_PAIR 1\n"
"#define MAX_SHARED_TYPES 0\n"
"#define BLOCK_NBOR_BUILD 4\n"
"#define BLOCK_BIO_PAIR 2\n"
"#define BLOCK_ELLIPSE 2\n"
"#define WARP_SIZE 1\n"
"#define PPPM_BLOCK_1D 32\n"
"#define BLOCK_CELL_2D 1\n"
"#define BLOCK_CELL_ID 2\n"
"#define MAX_BIO_SHARED_TYPES 0\n"
"#endif\n"
"#ifdef PHI_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 16\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 1\n"
"#define BLOCK_PAIR 16\n"
"#define MAX_SHARED_TYPES 0\n"
"#define BLOCK_NBOR_BUILD 16\n"
"#define BLOCK_BIO_PAIR 16\n"
"#define BLOCK_ELLIPSE 16\n"
"#define WARP_SIZE 1\n"
"#define PPPM_BLOCK_1D 32\n"
"#define BLOCK_CELL_2D 4\n"
"#define BLOCK_CELL_ID 16\n"
"#define MAX_BIO_SHARED_TYPES 0\n"
"#endif\n"
"#ifdef GENERIC_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 16\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 1\n"
"#define BLOCK_PAIR 64\n"
"#define MAX_SHARED_TYPES 8\n"
"#define BLOCK_NBOR_BUILD 64\n"
"#define BLOCK_BIO_PAIR 64\n"
"#define WARP_SIZE 1\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#endif\n"
"#ifdef USE_OPENCL\n"
"#ifndef _SINGLE_SINGLE\n"
"#ifndef cl_khr_fp64\n"
"#ifndef cl_amd_fp64\n"
"#pragma OPENCL EXTENSION cl_khr_fp64 : enable\n"
"#endif\n"
"#endif\n"
"#if defined(cl_khr_fp64)\n"
"#pragma OPENCL EXTENSION cl_khr_fp64 : enable\n"
"#elif defined(cl_amd_fp64)\n"
"#pragma OPENCL EXTENSION cl_amd_fp64 : enable\n"
"#endif\n"
"#endif\n"
"#ifndef fast_mul\n"
"#define fast_mul(X,Y) (X)*(Y)\n"
"#endif\n"
"#ifndef ARCH\n"
"#define ARCH 0\n"
"#endif\n"
"#ifndef DRIVER\n"
"#define DRIVER 0\n"
"#endif\n"
"#define GLOBAL_ID_X get_global_id(0)\n"
"#define THREAD_ID_X get_local_id(0)\n"
"#define BLOCK_ID_X get_group_id(0)\n"
"#define BLOCK_SIZE_X get_local_size(0)\n"
"#define GLOBAL_SIZE_X get_global_size(0)\n"
"#define THREAD_ID_Y get_local_id(1)\n"
"#define BLOCK_ID_Y get_group_id(1)\n"
"#define __syncthreads() barrier(CLK_LOCAL_MEM_FENCE)\n"
"#define ucl_inline inline\n"
"#define fetch4(ans,i,x) ans=x[i]\n"
"#define fetch(ans,i,q) ans=q[i]\n"
"#define ucl_atan atan\n"
"#define ucl_cbrt cbrt\n"
"#define ucl_ceil ceil\n"
"#define ucl_abs fabs\n"
"#ifdef _DOUBLE_DOUBLE\n"
"#define NO_HARDWARE_TRANSCENDENTALS\n"
"#endif\n"
"#ifdef NO_HARDWARE_TRANSCENDENTALS\n"
"#define ucl_exp exp\n"
"#define ucl_powr powr\n"
"#define ucl_rsqrt rsqrt\n"
"#define ucl_sqrt sqrt\n"
"#define ucl_recip(x) ((numtyp)1.0/(x))\n"
"#else\n"
"#define ucl_exp native_exp\n"
"#define ucl_powr native_powr\n"
"#define ucl_rsqrt native_rsqrt\n"
"#define ucl_sqrt native_sqrt\n"
"#define ucl_recip native_recip\n"
"#endif\n"
"#endif\n"
"#ifndef PPPM_MAX_SPLINE\n"
"#define PPPM_MAX_SPLINE 8\n"
"#endif\n"
"#ifdef _DOUBLE_DOUBLE\n"
"#define numtyp double\n"
"#define numtyp2 double2\n"
"#define numtyp4 double4\n"
"#define acctyp double\n"
"#define acctyp4 double4\n"
"#endif\n"
"#ifdef _SINGLE_DOUBLE\n"
"#define numtyp float\n"
"#define numtyp2 float2\n"
"#define numtyp4 float4\n"
"#define acctyp double\n"
"#define acctyp4 double4\n"
"#endif\n"
"#ifndef numtyp\n"
"#define numtyp float\n"
"#define numtyp2 float2\n"
"#define numtyp4 float4\n"
"#define acctyp float\n"
"#define acctyp4 float4\n"
"#endif\n"
"#define EWALD_F (numtyp)1.12837917\n"
"#define EWALD_P (numtyp)0.3275911\n"
"#define A1 (numtyp)0.254829592\n"
"#define A2 (numtyp)-0.284496736\n"
"#define A3 (numtyp)1.421413741\n"
"#define A4 (numtyp)-1.453152027\n"
"#define A5 (numtyp)1.061405429\n"
"#define SBBITS 30\n"
"#define NEIGHMASK 0x3FFFFFFF\n"
"ucl_inline int sbmask(int j) { return j >> SBBITS & 3; };\n"
"#ifndef BLOCK_ELLIPSE\n"
"#define BLOCK_ELLIPSE BLOCK_PAIR\n"
"#endif\n"
"#if !defined(LAMMPS_SMALLSMALL) && !defined(LAMMPS_BIGBIG) && !defined(LAMMPS_SMALLBIG)\n"
"#define LAMMPS_SMALLBIG\n"
"#endif\n"

"#ifdef NV_KERNEL\n"
"#include \"lal_preprocessor.h\"\n"
"#endif\n"
"#define atom_info(t_per_atom, ii, tid, offset)                               \\\n"
"  tid=THREAD_ID_X;                                                           \\\n"
"  offset=tid & (t_per_atom-1);                                               \\\n"
"  ii=fast_mul((int)BLOCK_ID_X,(int)(BLOCK_SIZE_X)/t_per_atom)+tid/t_per_atom;\n"
"#define nbor_info(dev_nbor, dev_packed, nbor_pitch, t_per_atom, ii, offset,  \\\n"
"                  i, numj, n_stride, nbor_end, nbor_begin)                   \\\n"
"  i=dev_nbor[ii];                                                            \\\n"
"  nbor_begin=ii+nbor_pitch;                                                  \\\n"
"  numj=dev_nbor[nbor_begin];                                                 \\\n"
"  if (dev_nbor==dev_packed) {                                                \\\n"
"    nbor_begin+=nbor_pitch+fast_mul(ii,t_per_atom-1);                        \\\n"
"    n_stride=fast_mul(t_per_atom,nbor_pitch);                                \\\n"
"    nbor_end=nbor_begin+fast_mul(numj/t_per_atom,n_stride)+(numj & (t_per_atom-1)); \\\n"
"    nbor_begin+=offset;                                                      \\\n"
"  } else {                                                                   \\\n"
"    nbor_begin+=nbor_pitch;                                                  \\\n"
"    nbor_begin=dev_nbor[nbor_begin];                                         \\\n"
"    nbor_end=nbor_begin+numj;                                                \\\n"
"    n_stride=t_per_atom;                                                     \\\n"
"    nbor_begin+=offset;                                                      \\\n"
"  }\n"
"#if (ARCH < 300)\n"
"#define store_answers(f, energy, virial, ii, inum, tid, t_per_atom, offset, \\\n"
"                      eflag, vflag, ans, engv)                              \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    __local acctyp red_acc[6][BLOCK_PAIR];                                  \\\n"
"    red_acc[0][tid]=f.x;                                                    \\\n"
"    red_acc[1][tid]=f.y;                                                    \\\n"
"    red_acc[2][tid]=f.z;                                                    \\\n"
"    red_acc[3][tid]=energy;                                                 \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"      if (offset < s) {                                                     \\\n"
"        for (int r=0; r<4; r++)                                             \\\n"
"          red_acc[r][tid] += red_acc[r][tid+s];                             \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    f.x=red_acc[0][tid];                                                    \\\n"
"    f.y=red_acc[1][tid];                                                    \\\n"
"    f.z=red_acc[2][tid];                                                    \\\n"
"    energy=red_acc[3][tid];                                                 \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        red_acc[r][tid]=virial[r];                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"        if (offset < s) {                                                   \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            red_acc[r][tid] += red_acc[r][tid+s];                           \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        virial[r]=red_acc[r][tid];                                          \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    int ei=ii;                                                              \\\n"
"    if (eflag>0) {                                                          \\\n"
"      engv[ei]=energy*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        engv[ei]=virial[i]*(acctyp)0.5;                                     \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    ans[ii]=f;                                                              \\\n"
"  }\n"
"#define store_answers_q(f, energy, e_coul, virial, ii, inum, tid,           \\\n"
"                        t_per_atom, offset, eflag, vflag, ans, engv)        \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    __local acctyp red_acc[6][BLOCK_PAIR];                                  \\\n"
"    red_acc[0][tid]=f.x;                                                    \\\n"
"    red_acc[1][tid]=f.y;                                                    \\\n"
"    red_acc[2][tid]=f.z;                                                    \\\n"
"    red_acc[3][tid]=energy;                                                 \\\n"
"    red_acc[4][tid]=e_coul;                                                 \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"      if (offset < s) {                                                     \\\n"
"        for (int r=0; r<5; r++)                                             \\\n"
"          red_acc[r][tid] += red_acc[r][tid+s];                             \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    f.x=red_acc[0][tid];                                                    \\\n"
"    f.y=red_acc[1][tid];                                                    \\\n"
"    f.z=red_acc[2][tid];                                                    \\\n"
"    energy=red_acc[3][tid];                                                 \\\n"
"    e_coul=red_acc[4][tid];                                                 \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        red_acc[r][tid]=virial[r];                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"        if (offset < s) {                                                   \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            red_acc[r][tid] += red_acc[r][tid+s];                           \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        virial[r]=red_acc[r][tid];                                          \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    int ei=ii;                                                              \\\n"
"    if (eflag>0) {                                                          \\\n"
"      engv[ei]=energy*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"      engv[ei]=e_coul*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        engv[ei]=virial[i]*(acctyp)0.5;                                     \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    ans[ii]=f;                                                              \\\n"
"  }\n"
"#else\n"
"#define store_answers(f, energy, virial, ii, inum, tid, t_per_atom, offset, \\\n"
"                      eflag, vflag, ans, engv)                              \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"        f.x += shfl_xor(f.x, s, t_per_atom);                                \\\n"
"        f.y += shfl_xor(f.y, s, t_per_atom);                                \\\n"
"        f.z += shfl_xor(f.z, s, t_per_atom);                                \\\n"
"        energy += shfl_xor(energy, s, t_per_atom);                          \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            virial[r] += shfl_xor(virial[r], s, t_per_atom);                \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    int ei=ii;                                                              \\\n"
"    if (eflag>0) {                                                          \\\n"
"      engv[ei]=energy*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        engv[ei]=virial[i]*(acctyp)0.5;                                     \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    ans[ii]=f;                                                              \\\n"
"  }\n"
"#define store_answers_q(f, energy, e_coul, virial, ii, inum, tid,           \\\n"
"                        t_per_atom, offset, eflag, vflag, ans, engv)        \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"      f.x += shfl_xor(f.x, s, t_per_atom);                                  \\\n"
"      f.y += shfl_xor(f.y, s, t_per_atom);                                  \\\n"
"      f.z += shfl_xor(f.z, s, t_per_atom);                                  \\\n"
"      energy += shfl_xor(energy, s, t_per_atom);                            \\\n"
"      e_coul += shfl_xor(e_coul, s, t_per_atom);                            \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            virial[r] += shfl_xor(virial[r], s, t_per_atom);                \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    int ei=ii;                                                              \\\n"
"    if (eflag>0) {                                                          \\\n"
"      engv[ei]=energy*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"      engv[ei]=e_coul*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        engv[ei]=virial[i]*(acctyp)0.5;                                     \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    ans[ii]=f;                                                              \\\n"
"  }\n"
"#endif\n"

"#ifdef NV_KERNEL\n"
"#include \"lal_ellipsoid_extra.h\"\n"
"#endif\n"
"#if (ARCH < 300)\n"
"#define store_answers_rt(f, tor, energy, virial, ii, astride, tid,           \\\n"
"                         t_per_atom, offset, eflag, vflag, ans, engv)        \\\n"
"  if (t_per_atom>1) {                                                        \\\n"
"    __local acctyp red_acc[7][BLOCK_PAIR];                                   \\\n"
"    red_acc[0][tid]=f.x;                                                     \\\n"
"    red_acc[1][tid]=f.y;                                                     \\\n"
"    red_acc[2][tid]=f.z;                                                     \\\n"
"    red_acc[3][tid]=tor.x;                                                   \\\n"
"    red_acc[4][tid]=tor.y;                                                   \\\n"
"    red_acc[5][tid]=tor.z;                                                   \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                          \\\n"
"      if (offset < s) {                                                      \\\n"
"        for (int r=0; r<6; r++)                                              \\\n"
"          red_acc[r][tid] += red_acc[r][tid+s];                              \\\n"
"      }                                                                      \\\n"
"    }                                                                        \\\n"
"    f.x=red_acc[0][tid];                                                     \\\n"
"    f.y=red_acc[1][tid];                                                     \\\n"
"    f.z=red_acc[2][tid];                                                     \\\n"
"    tor.x=red_acc[3][tid];                                                   \\\n"
"    tor.y=red_acc[4][tid];                                                   \\\n"
"    tor.z=red_acc[5][tid];                                                   \\\n"
"    if (eflag>0 || vflag>0) {                                                \\\n"
"      for (int r=0; r<6; r++)                                                \\\n"
"        red_acc[r][tid]=virial[r];                                           \\\n"
"      red_acc[6][tid]=energy;                                                \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                        \\\n"
"        if (offset < s) {                                                    \\\n"
"          for (int r=0; r<7; r++)                                            \\\n"
"            red_acc[r][tid] += red_acc[r][tid+s];                            \\\n"
"        }                                                                    \\\n"
"      }                                                                      \\\n"
"      for (int r=0; r<6; r++)                                                \\\n"
"        virial[r]=red_acc[r][tid];                                           \\\n"
"      energy=red_acc[6][tid];                                                \\\n"
"    }                                                                        \\\n"
"  }                                                                          \\\n"
"  if (offset==0) {                                                           \\\n"
"    __global acctyp *ap1=engv+ii;                                            \\\n"
"    if (eflag>0) {                                                           \\\n"
"      *ap1+=energy*(acctyp)0.5;                                              \\\n"
"      ap1+=astride;                                                          \\\n"
"    }                                                                        \\\n"
"    if (vflag>0) {                                                           \\\n"
"      for (int i=0; i<6; i++) {                                              \\\n"
"        *ap1+=virial[i]*(acctyp)0.5;                                         \\\n"
"        ap1+=astride;                                                        \\\n"
"      }                                                                      \\\n"
"    }                                                                        \\\n"
"    acctyp4 old=ans[ii];                                                     \\\n"
"    old.x+=f.x;                                                              \\\n"
"    old.y+=f.y;                                                              \\\n"
"    old.z+=f.z;                                                              \\\n"
"    ans[ii]=old;                                                             \\\n"
"    old=ans[ii+astride];                                                     \\\n"
"    old.x+=tor.x;                                                            \\\n"
"    old.y+=tor.y;                                                            \\\n"
"    old.z+=tor.z;                                                            \\\n"
"    ans[ii+astride]=old;                                                     \\\n"
"  }\n"
"#else\n"
"#define store_answers_rt(f, tor, energy, virial, ii, astride, tid,          \\\n"
"                         t_per_atom, offset, eflag, vflag, ans, engv)       \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"        f.x += shfl_xor(f.x, s, t_per_atom);                                \\\n"
"        f.y += shfl_xor(f.y, s, t_per_atom);                                \\\n"
"        f.z += shfl_xor(f.z, s, t_per_atom);                                \\\n"
"        tor.x += shfl_xor(tor.x, s, t_per_atom);                            \\\n"
"        tor.y += shfl_xor(tor.y, s, t_per_atom);                            \\\n"
"        tor.z += shfl_xor(tor.z, s, t_per_atom);                            \\\n"
"        energy += shfl_xor(energy, s, t_per_atom);                          \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            virial[r] += shfl_xor(virial[r], s, t_per_atom);                \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    __global acctyp *ap1=engv+ii;                                           \\\n"
"    if (eflag>0) {                                                          \\\n"
"      *ap1+=energy*(acctyp)0.5;                                             \\\n"
"      ap1+=astride;                                                         \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        *ap1+=virial[i]*(acctyp)0.5;                                        \\\n"
"        ap1+=astride;                                                       \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    acctyp4 old=ans[ii];                                                    \\\n"
"    old.x+=f.x;                                                             \\\n"
"    old.y+=f.y;                                                             \\\n"
"    old.z+=f.z;                                                             \\\n"
"    ans[ii]=old;                                                            \\\n"
"    old=ans[ii+astride];                                                    \\\n"
"    old.x+=tor.x;                                                           \\\n"
"    old.y+=tor.y;                                                           \\\n"
"    old.z+=tor.z;                                                           \\\n"
"    ans[ii+astride]=old;                                                    \\\n"
"  }\n"
"#endif\n"
"__kernel void k_resquared_ellipsoid_sphere(const __global numtyp4 *restrict x_,\n"
"                                           const __global numtyp4 *restrict q,\n"
"                                           const __global numtyp4 *restrict shape,\n"
"                                           const __global numtyp4 *restrict well,\n"
"                                           const __global numtyp *restrict splj,\n"
"                                           const __global numtyp2 *restrict sig_eps,\n"
"                                           const int ntypes,\n"
"                                           const __global int *dev_nbor,\n"
"                                           const int stride,\n"
"                                           __global acctyp4 *restrict ans,\n"
"                                           const int astride,\n"
"                                           __global acctyp *restrict engv,\n"
"                                           __global int *restrict err_flag,\n"
"                                           const int eflag, const int vflag,\n"
"                                           const int inum,\n"
"                                           const int t_per_atom) {\n"
"  int tid, ii, offset;\n"
"  atom_info(t_per_atom,ii,tid,offset);\n"
"  __local numtyp sp_lj[4];\n"
"  sp_lj[0]=splj[0];\n"
"  sp_lj[1]=splj[1];\n"
"  sp_lj[2]=splj[2];\n"
"  sp_lj[3]=splj[3];\n"
"  __local numtyp b_alpha, cr60, solv_f_a, solv_f_r;\n"
"  b_alpha=(numtyp)45.0/(numtyp)56.0;\n"
"  cr60=ucl_cbrt((numtyp)60.0);\n"
"  solv_f_a = (numtyp)3.0/((numtyp)16.0*ucl_atan((numtyp)1.0)*-(numtyp)36.0);\n"
"  solv_f_r = (numtyp)3.0/((numtyp)16.0*ucl_atan((numtyp)1.0)*(numtyp)2025.0);\n"
"  acctyp energy=(acctyp)0;\n"
"  acctyp4 f;\n"
"  f.x=(acctyp)0;\n"
"  f.y=(acctyp)0;\n"
"  f.z=(acctyp)0;\n"
"  acctyp4 tor;\n"
"  tor.x=(acctyp)0;\n"
"  tor.y=(acctyp)0;\n"
"  tor.z=(acctyp)0;\n"
"  acctyp virial[6];\n"
"  for (int i=0; i<6; i++)\n"
"    virial[i]=(acctyp)0;\n"
"  if (ii<inum) {\n"
"    int nbor, nbor_end;\n"
"    int i, numj;\n"
"    __local int n_stride;\n"
"    nbor_info_e(dev_nbor,stride,t_per_atom,ii,offset,i,numj,\n"
"                n_stride,nbor_end,nbor);\n"
"    numtyp4 ix; fetch4(ix,i,pos_tex);\n"
"    int itype=ix.w;\n"
"    numtyp a[9];           numtyp aTe[9];         numtyp lA_0[9], lA_1[9], lA_2[9]; \n"
"    numtyp4 ishape;\n"
"    ishape=shape[itype];\n"
"    numtyp ilshape=ishape.x*ishape.y*ishape.z;\n"
"    {\n"
"      gpu_quat_to_mat_trans(q,i,a);\n"
"      gpu_transpose_times_diag3(a,well[itype],aTe);\n"
"      gpu_rotation_generator_x(a,lA_0);\n"
"      gpu_rotation_generator_y(a,lA_1);\n"
"      gpu_rotation_generator_z(a,lA_2);\n"
"    }\n"
"    numtyp factor_lj;\n"
"    for ( ; nbor<nbor_end; nbor+=n_stride) {\n"
"      int j=dev_nbor[nbor];\n"
"      factor_lj = sp_lj[sbmask(j)];\n"
"      j &= NEIGHMASK;\n"
"      numtyp4 jx; fetch4(jx,j,pos_tex);\n"
"      int jtype=jx.w;\n"
"            numtyp r[3], rhat[3];\n"
"      numtyp rnorm;\n"
"      r[0] = jx.x-ix.x;\n"
"      r[1] = jx.y-ix.y;\n"
"      r[2] = jx.z-ix.z;\n"
"      rnorm = gpu_dot3(r,r);\n"
"      rnorm = ucl_rsqrt(rnorm);\n"
"      rhat[0] = r[0]*rnorm;\n"
"      rhat[1] = r[1]*rnorm;\n"
"      rhat[2] = r[2]*rnorm;\n"
"      numtyp sigma, epsilon;\n"
"      int mtype=fast_mul(ntypes,itype)+jtype;\n"
"      sigma = sig_eps[mtype].x;\n"
"      epsilon = sig_eps[mtype].y*factor_lj;\n"
"      numtyp aTs[9];\n"
"      numtyp4 scorrect;\n"
"      numtyp half_sigma=sigma*(numtyp)0.5;\n"
"      scorrect.x = ishape.x+half_sigma;\n"
"      scorrect.y = ishape.y+half_sigma;\n"
"      scorrect.z = ishape.z+half_sigma;\n"
"      scorrect.x = scorrect.x * scorrect.x * (numtyp)0.5;\n"
"      scorrect.y = scorrect.y * scorrect.y * (numtyp)0.5;\n"
"      scorrect.z = scorrect.z * scorrect.z * (numtyp)0.5;\n"
"      gpu_transpose_times_diag3(a,scorrect,aTs);\n"
"      \n"
"      numtyp gamma[9], s[3];\n"
"      gpu_times3(aTs,a,gamma);\n"
"      gpu_mldivide3(gamma,rhat,s,err_flag);\n"
"      numtyp sigma12 = ucl_rsqrt((numtyp)0.5*gpu_dot3(s,rhat));\n"
"      numtyp temp[9], w[3];\n"
"      gpu_times3(aTe,a,temp);\n"
"      temp[0] += (numtyp)1.0;\n"
"      temp[4] += (numtyp)1.0;\n"
"      temp[8] += (numtyp)1.0;\n"
"      gpu_mldivide3(temp,rhat,w,err_flag);\n"
"      numtyp h12 = ucl_recip(rnorm)-sigma12;\n"
"      numtyp chi = (numtyp)2.0*gpu_dot3(rhat,w);\n"
"      numtyp sigh = sigma/h12;\n"
"      numtyp tprod = chi*sigh;\n"
"      numtyp Ua, Ur;\n"
"      numtyp h12p3 = h12*h12*h12;\n"
"      numtyp sigmap3 = sigma*sigma*sigma;\n"
"      numtyp stemp = h12*(numtyp)0.5;\n"
"      Ua = (ishape.x+stemp)*(ishape.y+stemp)*(ishape.z+stemp)*h12p3/(numtyp)8.0;\n"
"      Ua = ((numtyp)1.0+(numtyp)3.0*tprod)*ilshape/Ua;\n"
"      Ua = epsilon*Ua*sigmap3*solv_f_a;\n"
"      stemp = h12/cr60;\n"
"      Ur = (ishape.x+stemp)*(ishape.y+stemp)*(ishape.z+stemp)*h12p3/\n"
"           (numtyp)60.0;\n"
"      Ur = ((numtyp)1.0+b_alpha*tprod)*ilshape/Ur;\n"
"      numtyp sigh6=sigh*sigh*sigh;\n"
"      sigh6*=sigh6;\n"
"      Ur = epsilon*Ur*sigmap3*sigh6*solv_f_r;\n"
"      energy+=Ua+Ur;\n"
"      \n"
"      numtyp fourw[3], spr[3];\n"
"      numtyp sec = sigma*chi;\n"
"      numtyp sigma12p3 = sigma12*sigma12*sigma12;\n"
"      fourw[0] = (numtyp)4.0*w[0];\n"
"      fourw[1] = (numtyp)4.0*w[1];\n"
"      fourw[2] = (numtyp)4.0*w[2];\n"
"      spr[0] = (numtyp)0.5*sigma12p3*s[0];\n"
"      spr[1] = (numtyp)0.5*sigma12p3*s[1];\n"
"      spr[2] = (numtyp)0.5*sigma12p3*s[2];\n"
"      stemp = ucl_recip(ishape.x*(numtyp)2.0+h12)+\n"
"              ucl_recip(ishape.y*(numtyp)2.0+h12)+\n"
"              ucl_recip(ishape.z*(numtyp)2.0+h12)+\n"
"              (numtyp)3.0/h12;\n"
"      numtyp hsec = ucl_recip(h12+(numtyp)3.0*sec);\n"
"      numtyp dspu = ucl_recip(h12)-hsec+stemp;\n"
"      numtyp pbsu = (numtyp)3.0*sigma*hsec;\n"
"      stemp = ucl_recip(ishape.x*cr60+h12)+\n"
"              ucl_recip(ishape.y*cr60+h12)+\n"
"              ucl_recip(ishape.z*cr60+h12)+\n"
"              (numtyp)3.0/h12;\n"
"      hsec = ucl_recip(h12+b_alpha*sec);\n"
"      numtyp dspr = (numtyp)7.0/h12-hsec+stemp;\n"
"      numtyp pbsr = b_alpha*sigma*hsec;\n"
"      #pragma unroll\n"
"      for (int i=0; i<3; i++) {\n"
"        numtyp u[3];\n"
"        u[0] = -rhat[i]*rhat[0];\n"
"        u[1] = -rhat[i]*rhat[1];\n"
"        u[2] = -rhat[i]*rhat[2];\n"
"        u[i] += (numtyp)1.0;\n"
"        u[0] *= rnorm;\n"
"        u[1] *= rnorm;\n"
"        u[2] *= rnorm;\n"
"        numtyp dchi = gpu_dot3(u,fourw);\n"
"        numtyp dh12 = rhat[i]+gpu_dot3(u,spr);\n"
"        numtyp dUa = pbsu*dchi-dh12*dspu;\n"
"        numtyp dUr = pbsr*dchi-dh12*dspr;\n"
"        numtyp force=dUr*Ur+dUa*Ua;\n"
"        if (i==0) {\n"
"          f.x+=force;\n"
"          if (vflag>0)\n"
"            virial[0]+=-r[0]*force;\n"
"        } else if (i==1) {\n"
"          f.y+=force;\n"
"          if (vflag>0) {\n"
"            virial[1]+=-r[1]*force;\n"
"            virial[3]+=-r[0]*force;\n"
"          }\n"
"        } else {\n"
"          f.z+=force;\n"
"          if (vflag>0) {\n"
"            virial[2]+=-r[2]*force;\n"
"            virial[4]+=-r[0]*force;\n"
"            virial[5]+=-r[1]*force;\n"
"          }\n"
"        }\n"
"      }\n"
"            numtyp fwae[3];\n"
"      gpu_row_times3(fourw,aTe,fwae);\n"
"      {\n"
"        numtyp tempv[3], p[3], lAtwo[9];\n"
"        gpu_times_column3(lA_0,rhat,p);\n"
"        gpu_times_column3(lA_0,w,tempv);\n"
"        numtyp dchi = -gpu_dot3(fwae,tempv);\n"
"        gpu_times3(aTs,lA_0,lAtwo);\n"
"        gpu_times_column3(lAtwo,spr,tempv);\n"
"        numtyp dh12 = -gpu_dot3(s,tempv);\n"
"        numtyp dUa = pbsu*dchi-dh12*dspu;\n"
"        numtyp dUr = pbsr*dchi-dh12*dspr;\n"
"        tor.x -= (dUa*Ua+dUr*Ur);\n"
"      }\n"
"      {\n"
"        numtyp tempv[3], p[3], lAtwo[9];\n"
"        gpu_times_column3(lA_1,rhat,p);\n"
"        gpu_times_column3(lA_1,w,tempv);\n"
"        numtyp dchi = -gpu_dot3(fwae,tempv);\n"
"        gpu_times3(aTs,lA_1,lAtwo);\n"
"        gpu_times_column3(lAtwo,spr,tempv);\n"
"        numtyp dh12 = -gpu_dot3(s,tempv);\n"
"        numtyp dUa = pbsu*dchi-dh12*dspu;\n"
"        numtyp dUr = pbsr*dchi-dh12*dspr;\n"
"        tor.y -= (dUa*Ua+dUr*Ur);\n"
"      }\n"
"      {\n"
"        numtyp tempv[3], p[3], lAtwo[9];\n"
"        gpu_times_column3(lA_2,rhat,p);\n"
"        gpu_times_column3(lA_2,w,tempv);\n"
"        numtyp dchi = -gpu_dot3(fwae,tempv);\n"
"        gpu_times3(aTs,lA_2,lAtwo);\n"
"        gpu_times_column3(lAtwo,spr,tempv);\n"
"        numtyp dh12 = -gpu_dot3(s,tempv);\n"
"        numtyp dUa = pbsu*dchi-dh12*dspu;\n"
"        numtyp dUr = pbsr*dchi-dh12*dspr;\n"
"        tor.z -= (dUa*Ua+dUr*Ur);\n"
"      }\n"
"    }     store_answers_rt(f,tor,energy,virial,ii,astride,tid,t_per_atom,offset,eflag,\n"
"                     vflag,ans,engv);\n"
"  } }\n"
"__kernel void k_resquared_sphere_ellipsoid(const __global numtyp4 *restrict x_,\n"
"                                           const __global numtyp4 *restrict q,\n"
"                                           const __global numtyp4 *restrict shape,\n"
"                                           const __global numtyp4 *restrict well,\n"
"                                           const __global numtyp *restrict splj,\n"
"                                           const __global numtyp2 *restrict sig_eps,\n"
"                                           const int ntypes,\n"
"                                           const __global int *dev_nbor,\n"
"                                           const int stride,\n"
"                                           __global acctyp4 *restrict ans,\n"
"                                           __global acctyp *restrict engv,\n"
"                                           __global int *restrict err_flag,\n"
"                                           const int eflag, const int vflag,\n"
"                                           const int start, const int inum,\n"
"                                           const int t_per_atom) {\n"
"  int tid, ii, offset;\n"
"  atom_info(t_per_atom,ii,tid,offset);\n"
"  ii+=start;\n"
"  __local numtyp sp_lj[4];\n"
"  sp_lj[0]=splj[0];\n"
"  sp_lj[1]=splj[1];\n"
"  sp_lj[2]=splj[2];\n"
"  sp_lj[3]=splj[3];\n"
"  __local numtyp b_alpha, cr60, solv_f_a, solv_f_r;\n"
"  b_alpha=(numtyp)45.0/(numtyp)56.0;\n"
"  cr60=ucl_cbrt((numtyp)60.0);\n"
"  solv_f_a = (numtyp)3.0/((numtyp)16.0*ucl_atan((numtyp)1.0)*-(numtyp)36.0);\n"
"  solv_f_r = (numtyp)3.0/((numtyp)16.0*ucl_atan((numtyp)1.0)*(numtyp)2025.0);\n"
"  acctyp energy=(acctyp)0;\n"
"  acctyp4 f;\n"
"  f.x=(acctyp)0;\n"
"  f.y=(acctyp)0;\n"
"  f.z=(acctyp)0;\n"
"  acctyp virial[6];\n"
"  for (int i=0; i<6; i++)\n"
"    virial[i]=(acctyp)0;\n"
"  if (ii<inum) {\n"
"    int nbor, nbor_end;\n"
"    int j, numj;\n"
"    __local int n_stride;\n"
"    nbor_info_e(dev_nbor,stride,t_per_atom,ii,offset,j,numj,\n"
"                n_stride,nbor_end,nbor);\n"
"    numtyp4 jx; fetch4(jx,j,pos_tex);\n"
"    int jtype=jx.w;\n"
"    numtyp factor_lj;\n"
"    for ( ; nbor<nbor_end; nbor+=n_stride) {\n"
"      int i=dev_nbor[nbor];\n"
"      factor_lj = sp_lj[sbmask(i)];\n"
"      i &= NEIGHMASK;\n"
"      numtyp4 ix; fetch4(ix,i,pos_tex);\n"
"      int itype=ix.w;\n"
"      numtyp a[9];             numtyp aTe[9];           numtyp4 ishape;\n"
"      ishape=shape[itype];\n"
"      gpu_quat_to_mat_trans(q,i,a);\n"
"      gpu_transpose_times_diag3(a,well[itype],aTe);\n"
"            numtyp r[3], rhat[3];\n"
"      numtyp rnorm;\n"
"      r[0] = ix.x-jx.x;\n"
"      r[1] = ix.y-jx.y;\n"
"      r[2] = ix.z-jx.z;\n"
"      rnorm = gpu_dot3(r,r);\n"
"      rnorm = ucl_rsqrt(rnorm);\n"
"      rhat[0] = r[0]*rnorm;\n"
"      rhat[1] = r[1]*rnorm;\n"
"      rhat[2] = r[2]*rnorm;\n"
"      numtyp sigma, epsilon;\n"
"      int mtype=fast_mul(ntypes,itype)+jtype;\n"
"      sigma = sig_eps[mtype].x;\n"
"      epsilon = sig_eps[mtype].y*factor_lj;\n"
"      numtyp aTs[9];\n"
"      numtyp4 scorrect;\n"
"      numtyp half_sigma=sigma * (numtyp)0.5;\n"
"      scorrect.x = ishape.x+half_sigma;\n"
"      scorrect.y = ishape.y+half_sigma;\n"
"      scorrect.z = ishape.z+half_sigma;\n"
"      scorrect.x = scorrect.x * scorrect.x * (numtyp)0.5;\n"
"      scorrect.y = scorrect.y * scorrect.y * (numtyp)0.5;\n"
"      scorrect.z = scorrect.z * scorrect.z * (numtyp)0.5;\n"
"      gpu_transpose_times_diag3(a,scorrect,aTs);\n"
"      \n"
"      numtyp gamma[9], s[3];\n"
"      gpu_times3(aTs,a,gamma);\n"
"      gpu_mldivide3(gamma,rhat,s,err_flag);\n"
"      numtyp sigma12 = ucl_rsqrt((numtyp)0.5*gpu_dot3(s,rhat));\n"
"      numtyp temp[9], w[3];\n"
"      gpu_times3(aTe,a,temp);\n"
"      temp[0] += (numtyp)1.0;\n"
"      temp[4] += (numtyp)1.0;\n"
"      temp[8] += (numtyp)1.0;\n"
"      gpu_mldivide3(temp,rhat,w,err_flag);\n"
"      numtyp h12 = ucl_recip(rnorm)-sigma12;\n"
"      numtyp chi = (numtyp)2.0*gpu_dot3(rhat,w);\n"
"      numtyp sigh = sigma/h12;\n"
"      numtyp tprod = chi*sigh;\n"
"      numtyp Ua, Ur;\n"
"      numtyp h12p3 = h12*h12*h12;\n"
"      numtyp sigmap3 = sigma*sigma*sigma;\n"
"      numtyp stemp = h12/(numtyp)2.0;\n"
"      Ua = (ishape.x+stemp)*(ishape.y+stemp)*(ishape.z+stemp)*h12p3/(numtyp)8.0;\n"
"      numtyp ilshape=ishape.x*ishape.y*ishape.z;\n"
"      Ua = ((numtyp)1.0+(numtyp)3.0*tprod)*ilshape/Ua;\n"
"      Ua = epsilon*Ua*sigmap3*solv_f_a;\n"
"      stemp = h12/cr60;\n"
"      Ur = (ishape.x+stemp)*(ishape.y+stemp)*(ishape.z+stemp)*h12p3/\n"
"           (numtyp)60.0;\n"
"      Ur = ((numtyp)1.0+b_alpha*tprod)*ilshape/Ur;\n"
"      numtyp sigh6=sigh*sigh*sigh;\n"
"      sigh6*=sigh6;\n"
"      Ur = epsilon*Ur*sigmap3*sigh6*solv_f_r;\n"
"      energy+=Ua+Ur;\n"
"      \n"
"      numtyp fourw[3], spr[3];\n"
"      numtyp sec = sigma*chi;\n"
"      numtyp sigma12p3 = sigma12*sigma12*sigma12;\n"
"      fourw[0] = (numtyp)4.0*w[0];\n"
"      fourw[1] = (numtyp)4.0*w[1];\n"
"      fourw[2] = (numtyp)4.0*w[2];\n"
"      spr[0] = (numtyp)0.5*sigma12p3*s[0];\n"
"      spr[1] = (numtyp)0.5*sigma12p3*s[1];\n"
"      spr[2] = (numtyp)0.5*sigma12p3*s[2];\n"
"      stemp = ucl_recip(ishape.x*(numtyp)2.0+h12)+\n"
"              ucl_recip(ishape.y*(numtyp)2.0+h12)+\n"
"              ucl_recip(ishape.z*(numtyp)2.0+h12)+\n"
"              (numtyp)3.0/h12;\n"
"      numtyp hsec = ucl_recip(h12+(numtyp)3.0*sec);\n"
"      numtyp dspu = ucl_recip(h12)-hsec+stemp;\n"
"      numtyp pbsu = (numtyp)3.0*sigma*hsec;\n"
"      stemp = ucl_recip(ishape.x*cr60+h12)+\n"
"              ucl_recip(ishape.y*cr60+h12)+\n"
"              ucl_recip(ishape.z*cr60+h12)+\n"
"              (numtyp)3.0/h12;\n"
"      hsec = ucl_recip(h12+b_alpha*sec);\n"
"      numtyp dspr = (numtyp)7.0/h12-hsec+stemp;\n"
"      numtyp pbsr = b_alpha*sigma*hsec;\n"
"      #pragma unroll\n"
"      for (int i=0; i<3; i++) {\n"
"        numtyp u[3];\n"
"        u[0] = -rhat[i]*rhat[0];\n"
"        u[1] = -rhat[i]*rhat[1];\n"
"        u[2] = -rhat[i]*rhat[2];\n"
"        u[i] += (numtyp)1.0;\n"
"        u[0] *= rnorm;\n"
"        u[1] *= rnorm;\n"
"        u[2] *= rnorm;\n"
"        numtyp dchi = gpu_dot3(u,fourw);\n"
"        numtyp dh12 = rhat[i]+gpu_dot3(u,spr);\n"
"        numtyp dUa = pbsu*dchi-dh12*dspu;\n"
"        numtyp dUr = pbsr*dchi-dh12*dspr;\n"
"        numtyp force=dUr*Ur+dUa*Ua;\n"
"        if (i==0) {\n"
"          f.x+=force;\n"
"          if (vflag>0)\n"
"            virial[0]+=-r[0]*force;\n"
"        } else if (i==1) {\n"
"          f.y+=force;\n"
"          if (vflag>0) {\n"
"            virial[1]+=-r[1]*force;\n"
"            virial[3]+=-r[0]*force;\n"
"          }\n"
"        } else {\n"
"          f.z+=force;\n"
"          if (vflag>0) {\n"
"            virial[2]+=-r[2]*force;\n"
"            virial[4]+=-r[0]*force;\n"
"            virial[5]+=-r[1]*force;\n"
"          }\n"
"        }\n"
"      }\n"
"    }     store_answers(f,energy,virial,ii,inum,tid,t_per_atom,offset,eflag,vflag,\n"
"                  ans,engv);\n"
"  } }\n"
"__kernel void k_resquared_lj(const __global numtyp4 *restrict x_,\n"
"                             const __global numtyp4 *restrict lj1,\n"
"                             const __global numtyp4 *restrict lj3,\n"
"                             const int lj_types,\n"
"                             const __global numtyp *restrict gum,\n"
"                             const int stride,\n"
"                             const __global int *dev_ij,\n"
"                             __global acctyp4 *restrict ans,\n"
"                             __global acctyp *restrict engv,\n"
"                             __global int *restrict err_flag,\n"
"                             const int eflag, const int vflag, const int start,\n"
"                             const int inum, const int t_per_atom) {\n"
"  int tid, ii, offset;\n"
"  atom_info(t_per_atom,ii,tid,offset);\n"
"  ii+=start;\n"
"  __local numtyp sp_lj[4];\n"
"  sp_lj[0]=gum[0];\n"
"  sp_lj[1]=gum[1];\n"
"  sp_lj[2]=gum[2];\n"
"  sp_lj[3]=gum[3];\n"
"  acctyp energy=(acctyp)0;\n"
"  acctyp4 f;\n"
"  f.x=(acctyp)0;\n"
"  f.y=(acctyp)0;\n"
"  f.z=(acctyp)0;\n"
"  acctyp virial[6];\n"
"  for (int i=0; i<6; i++)\n"
"    virial[i]=(acctyp)0;\n"
"  if (ii<inum) {\n"
"    int nbor, nbor_end;\n"
"    int i, numj;\n"
"    __local int n_stride;\n"
"    nbor_info_e(dev_ij,stride,t_per_atom,ii,offset,i,numj,\n"
"                n_stride,nbor_end,nbor);\n"
"    numtyp4 ix; fetch4(ix,i,pos_tex);\n"
"    int itype=ix.w;\n"
"    numtyp factor_lj;\n"
"    for ( ; nbor<nbor_end; nbor+=n_stride) {\n"
"      int j=dev_ij[nbor];\n"
"      factor_lj = sp_lj[sbmask(j)];\n"
"      j &= NEIGHMASK;\n"
"      numtyp4 jx; fetch4(jx,j,pos_tex);\n"
"      int jtype=jx.w;\n"
"            numtyp delx = ix.x-jx.x;\n"
"      numtyp dely = ix.y-jx.y;\n"
"      numtyp delz = ix.z-jx.z;\n"
"      numtyp r2inv = delx*delx+dely*dely+delz*delz;\n"
"      int ii=itype*lj_types+jtype;\n"
"      if (r2inv<lj1[ii].z && lj1[ii].w==SPHERE_SPHERE) {\n"
"        r2inv=ucl_recip(r2inv);\n"
"        numtyp r6inv = r2inv*r2inv*r2inv;\n"
"        numtyp force = r2inv*r6inv*(lj1[ii].x*r6inv-lj1[ii].y);\n"
"        force*=factor_lj;\n"
"        f.x+=delx*force;\n"
"        f.y+=dely*force;\n"
"        f.z+=delz*force;\n"
"        if (eflag>0) {\n"
"          numtyp e=r6inv*(lj3[ii].x*r6inv-lj3[ii].y);\n"
"          energy+=factor_lj*(e-lj3[ii].z);\n"
"        }\n"
"        if (vflag>0) {\n"
"          virial[0] += delx*delx*force;\n"
"          virial[1] += dely*dely*force;\n"
"          virial[2] += delz*delz*force;\n"
"          virial[3] += delx*dely*force;\n"
"          virial[4] += delx*delz*force;\n"
"          virial[5] += dely*delz*force;\n"
"        }\n"
"      }\n"
"    }     acc_answers(f,energy,virial,ii,inum,tid,t_per_atom,offset,eflag,vflag,\n"
"                ans,engv);\n"
"  } }\n"
"__kernel void k_resquared_lj_fast(const __global numtyp4 *restrict x_,\n"
"                                  const __global numtyp4 *restrict lj1_in,\n"
"                                  const __global numtyp4 *restrict lj3_in,\n"
"                                  const __global numtyp *restrict gum,\n"
"                                  const int stride,\n"
"                                  const __global int *dev_ij,\n"
"                                  __global acctyp4 *restrict ans,\n"
"                                  __global acctyp *restrict engv,\n"
"                                  __global int *restrict err_flag,\n"
"                                  const int eflag, const int vflag,\n"
"                                  const int start, const int inum,\n"
"                                  const int t_per_atom) {\n"
"  int tid, ii, offset;\n"
"  atom_info(t_per_atom,ii,tid,offset);\n"
"  ii+=start;\n"
"  __local numtyp sp_lj[4];\n"
"  __local numtyp4 lj1[MAX_SHARED_TYPES*MAX_SHARED_TYPES];\n"
"  __local numtyp4 lj3[MAX_SHARED_TYPES*MAX_SHARED_TYPES];\n"
"  if (tid<4)\n"
"    sp_lj[tid]=gum[tid];\n"
"  if (tid<MAX_SHARED_TYPES*MAX_SHARED_TYPES) {\n"
"    lj1[tid]=lj1_in[tid];\n"
"    if (eflag>0)\n"
"      lj3[tid]=lj3_in[tid];\n"
"  }\n"
"  acctyp energy=(acctyp)0;\n"
"  acctyp4 f;\n"
"  f.x=(acctyp)0;\n"
"  f.y=(acctyp)0;\n"
"  f.z=(acctyp)0;\n"
"  acctyp virial[6];\n"
"  for (int i=0; i<6; i++)\n"
"    virial[i]=(acctyp)0;\n"
"  __syncthreads();\n"
"  if (ii<inum) {\n"
"    int nbor, nbor_end;\n"
"    int i, numj;\n"
"    __local int n_stride;\n"
"    nbor_info_e(dev_ij,stride,t_per_atom,ii,offset,i,numj,\n"
"                n_stride,nbor_end,nbor);\n"
"    numtyp4 ix; fetch4(ix,i,pos_tex);\n"
"    int iw=ix.w;\n"
"    int itype=fast_mul((int)MAX_SHARED_TYPES,iw);\n"
"    numtyp factor_lj;\n"
"    for ( ; nbor<nbor_end; nbor+=n_stride) {\n"
"      int j=dev_ij[nbor];\n"
"      factor_lj = sp_lj[sbmask(j)];\n"
"      j &= NEIGHMASK;\n"
"      numtyp4 jx; fetch4(jx,j,pos_tex);\n"
"      int mtype=itype+jx.w;\n"
"            numtyp delx = ix.x-jx.x;\n"
"      numtyp dely = ix.y-jx.y;\n"
"      numtyp delz = ix.z-jx.z;\n"
"      numtyp r2inv = delx*delx+dely*dely+delz*delz;\n"
"      if (r2inv<lj1[mtype].z && lj1[mtype].w==SPHERE_SPHERE) {\n"
"        r2inv=ucl_recip(r2inv);\n"
"        numtyp r6inv = r2inv*r2inv*r2inv;\n"
"        numtyp force = factor_lj*r2inv*r6inv*(lj1[mtype].x*r6inv-lj1[mtype].y);\n"
"        f.x+=delx*force;\n"
"        f.y+=dely*force;\n"
"        f.z+=delz*force;\n"
"        if (eflag>0) {\n"
"          numtyp e=r6inv*(lj3[mtype].x*r6inv-lj3[mtype].y);\n"
"          energy+=factor_lj*(e-lj3[mtype].z);\n"
"        }\n"
"        if (vflag>0) {\n"
"          virial[0] += delx*delx*force;\n"
"          virial[1] += dely*dely*force;\n"
"          virial[2] += delz*delz*force;\n"
"          virial[3] += delx*dely*force;\n"
"          virial[4] += delx*delz*force;\n"
"          virial[5] += dely*delz*force;\n"
"        }\n"
"      }\n"
"    }     acc_answers(f,energy,virial,ii,inum,tid,t_per_atom,offset,eflag,vflag,\n"
"                ans,engv);\n"
"  } }\n"
;
